#ifdef GL_ES
precision highp float;
#endif


varying lowp vec2 v_texCoord;
uniform sampler2D u_texture;
const float PI2 = 57.2957795130824;
uniform float u_opacity;
uniform float u_1;

int intModulo(float a,float b) {
    float m = mod(a, b);
    return int(m+0.5);
}

void main() {
    vec2 c = v_texCoord - 0.5; //map to range [-0.5, 0.5]
    float r = length(c);
    float phi = -90.0 + u_1 / PI2;
    float x = r * cos(phi);
    float y = r * sin(phi);
    vec2 cc = vec2(x, y) + 0.5; //map to range [0.0, 1.0]
    vec4 color = texture2D(u_texture, cc);
    gl_FragColor = vec4(color.r, color.g, color.b, color.a * u_opacity);
}
