#ifdef GL_ES
precision mediump float;
#endif

varying lowp vec2 v_texCoord;
uniform sampler2D u_texture;
float blurRadius = 3.0;
float sampleNum = 4.0;
vec2 unit = vec2(0.01, 0.01);

vec4 blur(vec2 p)
{
    if (blurRadius > 0.0 && sampleNum > 1.0)
    {
        vec4 col = vec4(0.0, 0.0, 0.0, 0.0);

        float r = blurRadius;
        float sampleStep = r / sampleNum;

        float count = 0.0;

        for(float x = -r; x < r; x += sampleStep)
        {
            for(float y = -r; y < r; y += sampleStep)
            {
                float weight = (r - abs(x)) * (r - abs(y));
                col += texture2D(u_texture, p + vec2(x * unit.x, y * unit.y)) * weight;
                count += weight;
            }
        }

        return col / count;
    }

    return texture2D(u_texture, p);
}

void main()
{
    gl_FragColor = blur(v_texCoord);
}
