#ifdef GL_ES
precision mediump float;
#endif

// 1
varying vec2 v_texCoord;
uniform sampler2D u_texture;

void main()
{
    vec2 onePixel = vec2(1.0 / 100.0, 1.0 / 100.0); // AD **
    vec2 texCoord = v_texCoord;
    vec4 color = texture2D(u_texture, v_texCoord);
    float alphaOrig = color.a;
    float embossAmt = color.a * 0.5;
    embossAmt -= texture2D(u_texture, texCoord - onePixel).a * 5.0; // AD ** 5
    embossAmt += texture2D(u_texture, texCoord + onePixel).a * 5.0;
    if (embossAmt > 0.5) // AD ** mix
    {
        gl_FragColor = vec4(0.0, 0.0, 0.0, alphaOrig); // AD ** color
    }
    else if (embossAmt < 0.5) // AD ** mix
    {
        gl_FragColor = mix(vec4(1.0, 0.0, 0.0, alphaOrig), vec4(color.r, color.g, color.b, alphaOrig), embossAmt - 0.5);
    }
    else
    {
        gl_FragColor = vec4(color.r, color.g, color.b, alphaOrig);
    }
}
