#ifdef GL_ES
precision highp float;
#endif

varying lowp vec2 v_texCoord;
uniform sampler2D u_texture;
const float PI = 3.1415926535;


void main()
{
    // AD ** cant set size
     float aperture = 178.0;
     float apertureHalf = 0.5 * aperture * (PI / 180.0);
     float maxFactor = sin(apertureHalf);
     
     vec2 uv;
     vec2 xy = 2.0 * v_texCoord - 1.0;
     float d = length(xy);
     if (d < (2.0-maxFactor))
     {
       d = length(xy * maxFactor);
       float z = pow(1.0 - d * d, 0.5); // AD ** 0.7
       float r = atan(d, z) / PI;
       float phi = atan(xy.y, xy.x);
       
       uv.x = r * cos(phi) + 0.5;
       uv.y = r * sin(phi) + 0.5;
     }
     else
     {
       uv = v_texCoord.xy;
     }
     vec4 c = texture2D(u_texture, uv);
     gl_FragColor = c;
    
    
    /*
    float lensSize = 0.4;
    vec2 p = v_texCoord;
    vec2 d = p;
    float r = sqrt(dot(d, d)); // distance of pixel from mouse

    vec2 uv;
    vec3 col = vec3(0.0, 0.0, 0.0);
    if (r > lensSize+0.01)
    {
        uv = p;
        col = texture2D(u_texture, vec2(uv.x, -uv.y)).xyz;
    }
    else if (r < lensSize-0.01)
    {
        // Thanks to Paul Bourke for these formulas; see
        // http://paulbourke.net/miscellaneous/lenscorrection/
        // and .../lenscorrection/lens.c
        // Choose one formula to uncomment:
        // SQUAREXY:
        // uv = m + vec2(d.x * abs(d.x), d.y * abs(d.y));
        // SQUARER:
        uv = d * r; // a.k.a. m + normalize(d) * r * r
        // SINER:
        // uv = m + normalize(d) * sin(r * 3.14159 * 0.5);
        // ASINR:
        // uv = m + normalize(d) * asin(r) / (3.14159 * 0.5);
        col = texture2D(u_texture, vec2(uv.x, -uv.y)).xyz;
    }
    gl_FragColor = vec4(col, 1.0);
     
     */
    
    
    /*
    //normalized coords with some cheat
    vec2 p = v_texCoord;

    //screen proportion
    float prop = 1.0;
    //center coords
    vec2 m = vec2(0.5, 0.5 / prop);
    //vector from center to current fragment
    vec2 d = p - m;
    // distance of pixel from center
    float r = sqrt(dot(d, d));
    //amount of effect
    float power = 1.0;
    //radius of 1:1 effect
    float bind;
    if (power > 0.0) bind = sqrt(dot(m, m));//stick to corners
    else {if (prop < 1.0) bind = m.x; else bind = m.y;}//stick to borders

    //Weird formulas
    vec2 uv;
    if (power > 0.0)//fisheye
      uv = m + normalize(d) * tan(r * power) * bind / tan( bind * power);
    else if (power < 0.0)//antifisheye
     uv = m + normalize(d) * atan(r * -power * 10.0) * bind / atan(-power * bind * 10.0);
    else
      uv = p;//no effect for power = 1.0
    
    //Second part of cheat
    //for round effect, not elliptical
    vec3 col = texture2D(u_texture, vec2(uv.x, -uv.y * prop)).xyz;
                                                 
    gl_FragColor = vec4(col, 1.0);
     */
}
