#ifdef GL_ES
precision mediump float;
#endif

varying lowp vec2 v_texCoord;
uniform sampler2D u_texture;
uniform vec3 u_1;
uniform float u_2; // size
uniform float u_3; // opacity

float normpdf(in float x, in float sigma)
{
    return 0.39894*exp(-0.5*x*x/(sigma*sigma))/sigma;
}


void main()
{
    vec4 color = texture2D(u_texture, v_texCoord);
    if (color.a > 0.2)
    {
        gl_FragColor = color;
    }
    else
    {
        const int mSize = 11;
        const int kSize = (mSize-1)/2;
        float kernel[mSize];
        float final_colour = 0.0;
        float sigma = 7.0;
        float Z = 0.0;
        for (int j = 0; j <= kSize; ++j)
        {
            kernel[kSize+j] = kernel[kSize-j] = normpdf(float(j), sigma);
        }
        for (int j = 0; j < mSize; ++j)
        {
            Z += kernel[j];
        }
        for (int i=-kSize; i <= kSize; ++i)
        {
            for (int j=-kSize; j <= kSize; ++j)
            {
                final_colour += kernel[kSize+j]*kernel[kSize+i]*texture2D(u_texture, (v_texCoord+vec2(float(i)*0.012 * u_2 / 100.0,float(j)*0.012 * u_2 / 100.0))).a;
            }
        }
        float c = final_colour/(Z*Z);
        gl_FragColor = vec4(u_1.r, u_1.g, u_1.b, c * u_3 / 50.0);
    }
}
