varying vec2 v_texCoord;
uniform sampler2D u_texture;
uniform float u_opacity;
uniform vec3 color1;
uniform vec3 color2;
uniform vec3 color3;
uniform float pct_complete;
uniform float angle;

void main()
{
    vec4 color = texture2D(u_texture, v_texCoord);
    float yNew = 0.5 + (v_texCoord.x - 0.5) * sin(-angle) + (v_texCoord.y - 0.5) * cos(-angle);
    yNew = 1.0 - clamp(yNew, 0.0, 1.0);
    if (v_texCoord.x <= pct_complete)
    {
        vec3 mixed = vec3(mix(color1, color2, min(yNew / pct_complete, 1.0)));
        gl_FragColor = vec4(mixed, color.a * u_opacity);
    }
    else
    {
        gl_FragColor = vec4(color3, color.a * u_opacity);
    }
}
