#ifdef GL_ES
precision highp float;
#endif

#define M_PI 3.1415926535897932384626433832795

varying lowp vec2 v_texCoord;
uniform float u_opacity;
uniform vec3 color1;
uniform vec3 color2;
uniform vec3 color3;
uniform float radius_inner;
uniform float angle_current;
uniform float angle_total;
uniform float outside_opacity;


void main()
{
    float border = 0.0025;
    float radius_outer = 0.5;
    
    vec2 m = v_texCoord - vec2(0.5, 0.5);
    float dist = sqrt(m.x * m.x + m.y * m.y);
    
    vec2 centerPos = vec2(0.5, 0.5);
    float angle = atan(v_texCoord.x - centerPos.x, centerPos.y - v_texCoord.y) * 180.0 / M_PI;
    if (angle < 0.0)
    {
        angle += 360.0;
    }
    
    if (dist >= radius_inner &&
        dist <= radius_outer &&
        angle <= angle_total)
    {
        float opacity = u_opacity;
        if (angle <= angle_current)
        {
            while (angle + 360.0 < angle_current)
            {
                angle += 360.0;
            }
            gl_FragColor = vec4(mix(color1, color2, angle / angle_current), opacity);
        }
        else
        {
            opacity = u_opacity * outside_opacity;
            gl_FragColor = vec4(color3, opacity);
        }
        if (dist >= radius_outer - border &&
            dist <= radius_outer)
        {
            gl_FragColor = vec4(gl_FragColor.r, gl_FragColor.g, gl_FragColor.b, opacity * (radius_outer - dist) / border);
        }
        else if (dist >= radius_inner &&
            dist <= radius_inner + border)
        {
            gl_FragColor = vec4(gl_FragColor.r, gl_FragColor.g, gl_FragColor.b, opacity * (dist - radius_inner) / border);
        }
    }
    else
    {
        gl_FragColor = vec4(0.0, 0.0, 0.0, 0.0);
    }
}
