#define M_PI 3.1415926535897932384626433832795

varying lowp vec2 v_texCoord;
uniform sampler2D u_texture;
uniform float progress;


float getDistance(vec2 pos1_, vec2 pos2_)
{
    return max(abs(pos2_.x - pos1_.x), abs(pos2_.y - pos1_.y));
}

bool isBetween(float number_, float min_, float max_)
{
    return number_ >= min_ && number_ <= max_;
}

void main()
{
    vec4 colorMiddle = vec4(0.05, 0.05, 0.05, 0.75);
    float border = 0.005;
    float radius = 0.46;
    vec2 centerPos = vec2(0.5, 0.5);
    float distanceCenter = getDistance(centerPos, v_texCoord);
    float angle = atan(v_texCoord.x - centerPos.x, centerPos.y - v_texCoord.y) * 180.0 / M_PI;
    if (angle < 0.0)
    {
        angle += 360.0;
    }
    if (distanceCenter < radius)
    {
        gl_FragColor = colorMiddle;
    }
    else if (distanceCenter > 0.5)
    {
        gl_FragColor = vec4(1.0, 0.05, 0.05, 0.0);
    }
    else
    {
        vec4 color1;
        if (angle > 0.0 &&
            isBetween(angle, 0.0, progress * 360.0))
        {
            color1 = vec4(0.0, 197.0 / 255.0, 1.0, 1.0);
        }
        else
        {
            color1 = vec4(20.0 / 255.0, 102.0 / 255.0, 182.0 / 255.0, 1.0);
        }
        gl_FragColor = color1;
    }
}
