varying lowp vec2 v_texCoord;
uniform sampler2D u_texture;
uniform float u_size;


void main()
{
    vec4 color = texture2D(u_texture, v_texCoord);

    vec4 color0 = vec4(color.r, color.g, color.b, 0.0);
    vec4 color1 = vec4(color.r, color.g, color.b, 1.0);
    
    vec2 m = v_texCoord - vec2(0.5, 0.5);
    float dist = sqrt(m.x * m.x + m.y * m.y);
    
    if (dist <= u_size - 0.02)
    {
        // inner
        gl_FragColor = vec4(131.0 / 255.0, 82.0 / 255.0, 82.0 / 255.0,  1.0);
    }
    else if (dist <= u_size)
    {
        // outer
        gl_FragColor = vec4(80.0 / 255.0, 68.0 / 255.0, 68.0 / 255.0,  1.0);
    }
    else
    {
        gl_FragColor = vec4(0.0, 0.0, 0.0, 0.0);
    }
}
