#define M_PI 3.1415926535897932384626433832795

varying lowp vec2 v_texCoord;
uniform sampler2D u_texture;
uniform vec3 u_rgb;


void main()
{
    vec4 color = texture2D(u_texture, v_texCoord);
    float grey = dot(color.rgb, vec3(0.299, 0.587, 0.114));
    if (grey > 0.5)
    {
        color = vec4(mix(u_rgb, vec3(1.0, 1.0, 1.0), (grey - 0.5) / 0.5), 1.0);
    }
    else
    {
        color = vec4(vec3(grey) / 0.5 * u_rgb, 1.0);
    }
    gl_FragColor = color;
}
