varying lowp vec2 v_texCoord;
uniform sampler2D u_texture;
uniform float u_time;
uniform vec3 u_color;
uniform float u_scale;
uniform vec2 u_scaleRel;
uniform vec2 u_touch;
uniform int u_isCircle;

void main()
{
    vec4 color = texture2D(u_texture, v_texCoord);

    vec2 mCenter = v_texCoord - vec2(0.5, 0.5);
    float distCenter = sqrt(mCenter.x * mCenter.x * u_scaleRel.x + mCenter.y * mCenter.y * u_scaleRel.y);
    vec2 mTouch = v_texCoord - u_touch;
    float distTouch = sqrt(mTouch.x * mTouch.x * u_scaleRel.x + mTouch.y * mTouch.y * u_scaleRel.y);
    
    if ((distTouch < u_scale && u_isCircle == 0) ||
        (distTouch < u_scale && distCenter <= 0.5 && u_isCircle == 1))
    {
        gl_FragColor = vec4(u_color.r, u_color.g, u_color.b, 0.3 * (u_time < 0.4 ? u_time * 0.5 : u_time < 0.6 ? 0.2 : 0.2 * (3.0 - u_time) / 2.4));
    }
    else
    {
        gl_FragColor = vec4(0.0, 0.0, 0.0, 0.0);
    }
}
