varying lowp vec2 v_texCoord;
uniform sampler2D u_texture;
uniform float u_aspect;
uniform float u_radius;


float sdRoundRect(vec2 pos, vec2 ext, float r)
{
    return length(max(abs(pos) + vec2(r) - ext, 0.0)) - r;
}

void main()
{
    vec4 color = texture2D(u_texture, v_texCoord);
    vec2 aspectRatio = vec2(u_aspect, 1.0);
    float dist = sdRoundRect(v_texCoord.xy * aspectRatio - vec2(0.5, 0.5) * aspectRatio, vec2(0.5, 0.5) * aspectRatio, u_radius);
    gl_FragColor = color * smoothstep(0.005, 0.0, dist);
}
