#ifdef GL_ES
precision highp float;
#endif

varying lowp vec2 v_texCoord;
uniform sampler2D u_texture;
const float PI = 3.1415926535;


void main()
{
    // AD ** cant set size
     float aperture = 178.0;
     float apertureHalf = 0.5 * aperture * (PI / 180.0);
     float maxFactor = sin(apertureHalf);
     
     vec2 uv;
     vec2 xy = 2.0 * v_texCoord - 1.0;
     float d = length(xy);
     if (d < (2.0-maxFactor))
     {
       d = length(xy * maxFactor);
       float z = pow(1.0 - d * d, 0.7); // AD ** 0.7
       float r = atan(d, z) / PI;
       float phi = atan(xy.y, xy.x);
       
       uv.x = r * cos(phi) + 0.5;
       uv.y = r * sin(phi) + 0.5;
     }
     else
     {
       uv = v_texCoord.xy;
     }
     gl_FragColor = texture2D(u_texture, uv);
}
