#ifdef GL_ES
precision mediump float;
#endif

varying lowp vec2 v_texCoord;
uniform sampler2D u_texture;
uniform float u_1;
uniform float u_2;


bool isBetween(float number_, float min_, float max_)
{
    return number_ >= min_ && number_ <= max_;
}

void main()
{
    float x = v_texCoord.x + u_1;
    float y = v_texCoord.y + u_2;
    if (isBetween(x, 0.0, 1.0) &&
        isBetween(y, 0.0, 1.0))
    {
        gl_FragColor = texture2D(u_texture, vec2(x, y));
    }
    else
    {
        gl_FragColor = vec4(0.0, 0.0, 0.0, 0.0);
    }
}
