#ifdef GL_ES
precision mediump float;
#endif

varying lowp vec2 v_texCoord;
uniform sampler2D u_texture;
uniform float u_1;
uniform float u_aspect;
uniform float u_effect_3d;
uniform float u_scale_bottom;
uniform float u_fade;

float logValue(float y)
{
    return log(y) / log(6.0);
}

vec4 getColor()
{
    float x = (v_texCoord.x - 0.5) / mix(u_scale_bottom * 0.4 * (1.0 - u_effect_3d), u_scale_bottom, v_texCoord.y) + 0.5;
    if (x >= 0.0 &&
        x <= 1.0)
    {
        float y = logValue(v_texCoord.y) * u_aspect * 1.9 / u_scale_bottom + u_1;
        if (y >= 0.0 &&
            y <= 1.0)
        {
            vec4 color = texture2D(u_texture, vec2(x, y));
            return vec4(color.r, color.g, color.b, mix(color.a, color.a * v_texCoord.y, u_fade));
        }
    }
    return vec4(0.0, 0.0, 0.0, 0.0);
}

void main()
{
    gl_FragColor = getColor();
}
