#ifdef GL_ES
precision mediump float;
#endif

varying lowp vec2 v_texCoord;
uniform sampler2D u_texture;
uniform float u_width;
uniform float u_width2;
uniform float u_height;

vec4 getColor()
{
    float x = (v_texCoord.x - 0.5) / u_height + 0.5;
    if (x >= 0.0 &&
        x <= 1.0)
    {
        float y = (v_texCoord.y - 0.5) / mix(u_width2, u_width, x) + 0.5;
        if (y >= 0.0 &&
            y <= 1.0)
        {
            vec4 color = texture2D(u_texture, vec2(x, y));
            return color;
        }
    }
    return vec4(0.0, 0.0, 0.0, 0.0);
}

void main()
{
    gl_FragColor = getColor();
}
