#ifdef GL_ES
precision lowp float;
#endif

varying lowp vec2 v_texCoord;
uniform sampler2D u_texture;
uniform vec3 u_color;
uniform float u_color_margin;
uniform float u_black_pct_full;
uniform float u_1;

void main()
{
    vec4 color = texture2D(u_texture, v_texCoord);
    float threshold = 1.0 + u_color_margin - u_1 * u_black_pct_full;
    if (color.r >= threshold)
    {
        gl_FragColor = vec4(u_color.r, u_color.g, u_color.b, color.a);
    }
    else if (color.r > threshold - u_color_margin)
    {
        float opacity = color.a * ((u_color_margin - (threshold - color.r)) / u_color_margin);
        gl_FragColor = vec4(u_color.r, u_color.g, u_color.b, opacity);
    }
    else
    {
        gl_FragColor = vec4(0.0, 0.0, 0.0, 0.0);
    }
}
